using System;
using System.Runtime.InteropServices;

namespace c_sharp_example
{
	/// <summary>
	/// Example for use of sapien.dll from C#.
	/// </summary>
	class Example
	{
		[DllImport("sapien.dll")]
		public static extern void sapien_open(String port); 

		//convert string representation of command to hex code value 
		//(version: 1 for RoboSapien, 2 for RoboSapien V2, 3 for RoboPet)
		[DllImport("sapien.dll")]
		public static extern int sapien_decode(String sapien_cmd, int version);

		//send hex code value through serial port
		[DllImport("sapien.dll")]
		public static extern void sapien_send(int b, int version, int nowakeup);

		//close serial port
		[DllImport("sapien.dll")]
		public static extern void sapien_close();

		//use windows multimedia timers
		[DllImport("sapien.dll")]
		public static extern void sapien_usemmtimer(byte use);

		/// <summary>
		/// The main entry point for the application.
		/// </summary>

		[STAThread]
		static void Main(string[] args)
		{
			Console.WriteLine("Sending RoboPet Stop command to COM1...");
			sapien_open("COM1");
			sapien_send(0x28e, 3, 0);
			sapien_close();
		}	
    }
}
