/** A wrapper class around java dll version of the Sapien DLL that
 *  allows to send commands to RoboSapien and other WowWee robots using
 *  LEGO serial IR tower.
 */
public class SapienDLL {

    /** open serial port and setup. Returns handle to be passed to SapienSend, and SapienClose. */
	public static native long SapienOpen(String port);

	/** convert string representation of command to hex code value
	    (version: 1 for RoboSapien, 2 for RoboSapien V2, 3 for RoboPet) */
	public static native int SapienDecode(String sapienCmd, int version);

	/** send hex code value through serial port */
	public static native void SapienSend(long f, int b, int version, int nowakeup);

	/** close serial port */
	public static native void SapienClose(long f);

	/** enable use of windows multimedia timer (call it with 1 before other functions to enable MM timer) */
	public static native void SapienUseMMTimer(int use);

    static { System.loadLibrary("sapienjava"); }

}
