// sapienCtrl.cpp : Implementation of the CsapienCtrl ActiveX Control class.


#include "sapienocx.h"
#include "sapienCtrl.h"
#include "sapienPpg.h"
#include ".\sapienctrl.h"

#include "Mmsystem.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


IMPLEMENT_DYNCREATE(CsapienCtrl, COleControl)



// Message map

BEGIN_MESSAGE_MAP(CsapienCtrl, COleControl)
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()



// Dispatch map

BEGIN_DISPATCH_MAP(CsapienCtrl, COleControl)
	DISP_FUNCTION(CsapienCtrl, "open", open, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION(CsapienCtrl, "close", close, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CsapienCtrl, "decode", decode, VT_I2, VTS_BSTR VTS_I2)
	DISP_FUNCTION(CsapienCtrl, "send", send, VT_EMPTY, VTS_I2 VTS_I2)
END_DISPATCH_MAP()

// Event map
BEGIN_EVENT_MAP(CsapienCtrl, COleControl)
END_EVENT_MAP()



// Property pages
// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CsapienCtrl, 1)
	PROPPAGEID(CsapienPropPage::guid)
END_PROPPAGEIDS(CsapienCtrl)


// Initialize class factory and guid
IMPLEMENT_OLECREATE_EX(CsapienCtrl, "sapien",
	0x8eb07cca, 0xe4c4, 0x40be, 0xba, 0xc8, 0xd0, 0xcf, 0x86, 0x8d, 0x11, 0x1)

// Type library ID and version
IMPLEMENT_OLETYPELIB(CsapienCtrl, _tlid, _wVerMajor, _wVerMinor)


// Interface IDs
const IID BASED_CODE IID_Dsapienocx =
		{ 0xBBE12716, 0xE141, 0x4A2F, { 0xAC, 0xBE, 0x8B, 0x44, 0xCF, 0x7D, 0x2F, 0xCE } };
const IID BASED_CODE IID_DsapienocxEvents =
		{ 0xACF1DFDE, 0x300, 0x4E5C, { 0xB3, 0x46, 0xED, 0x18, 0xCE, 0xDC, 0x26, 0xD5 } };

// Control type information
static const DWORD BASED_CODE _dwsapienocxOleMisc =
	OLEMISC_INVISIBLEATRUNTIME |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CsapienCtrl, IDS_SAPIENOCX, _dwsapienocxOleMisc)

// CsapienCtrl::CsapienCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CsapienCtrl
BOOL CsapienCtrl::CsapienCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegApartmentThreading to 0.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_SAPIENOCX,
			IDB_SAPIENOCX,
			afxRegApartmentThreading,
			_dwsapienocxOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}

// CsapienCtrl::CsapienCtrl - Constructor
CsapienCtrl::CsapienCtrl()
{
	InitializeIIDs(&IID_Dsapienocx, &IID_DsapienocxEvents);
	// Initialize your control's instance data here.
	initialized = 0;
}



// CsapienCtrl::~CsapienCtrl - Destructor
CsapienCtrl::~CsapienCtrl()
{
	// Cleanup your control's instance data here.
	if (initialized) CloseHandle(handle);
	initialized = 0;
}

// CsapienCtrl::OnDraw - Drawing function
void CsapienCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	if (!pdc)
		return;

	// VC++ says: Replace the following code with your own drawing code.
	// pdc->FillRect(rcBounds, CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH)));
	// pdc->Ellipse(rcBounds);
}

// CsapienCtrl::DoPropExchange - Persistence support
void CsapienCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);
	// Call PX_ functions for each persistent custom property.
}

// CsapienCtrl::GetControlFlags -
// Flags to customize MFC's implementation of ActiveX controls.
//
DWORD CsapienCtrl::GetControlFlags()
{
	DWORD dwFlags = COleControl::GetControlFlags();


	// The control can activate without creating a window.
	// NOTE: when writing the control's message handlers, avoid using
	//		the m_hWnd member variable without first checking that its
	//		value is non-NULL.
	dwFlags |= windowlessActivate;
	return dwFlags;
}



// CsapienCtrl::OnResetState - Reset control to default state

void CsapienCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange
	// Reset any other control state here.
}



// CsapienCtrl message handlers

#define NCMDSAPIEN	128
#define NCMDSAPIEN2	73
#define NCMDPET		20

static double unit;
static HANDLE hevent;
static unsigned char ei;

static char *cmd[NCMDSAPIEN] = { "turn_right", "right_arm_up", "right_arm_out", "tilt_body_right",
	                "right_arm_down", "right_arm_in", "walk_forward", "walk_backward",
					"turn_left", "left_arm_up", "left_arm_out", "tilt_body_left",
					"left_arm_down", "left_arm_in", "stop", "-", "master_program",
					"play", "right_program", "left_program", "sonic_program",
					"-", "-", "-", "quiet_execute", "-", "quiet_execute_with_subroutines", "-",
					"-", "-", "-", "-",
					"right_turn_step", "right_hand_thump", "right_hand_throw",
					"sleep", "right_hand_pickup", "lean_backward", "forward_step",
					"backward_step", "left_turn_step", "left_hand_thump",
					"left_hand_throw", "listen", "left_hand_pickup", "lean_forward" ,
					"reset", "-", "master_execute", "wakeup", "right_execute", "left_execute",
					"sonic_execute", "-", "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
					"right_hand_strike_3", "right_hand_sweep",
					"burp", "right_hand_strike", "high_5", "right_hand_strike_1",
					"bulldozer", "oops", "left_hand_strike_3", "left_hand_sweep",
					"whistle", "left_hand_strike_2", "talkback", "left_hand_strike_1",
					"roar", "-", "all_demo", "power_off", "demo_1", "demo_2", "dance", "-", "karate_chop",
					"-","-","-","-","-","-","-","-","-","-","-","-","-","-","-","-","-","-","-","-",
					"-","-","-","-","-","-","-","-","-","-","-",
					"feet_shuffle", "-","-","-","-","nothing", "raise_arm_throw","-","-","-"  };

static char *cmd2[NCMDSAPIEN2] = { "_walking",
                        "stop",
						"sonic_sensors_on_off",
						"vision_systems_on_off",
						"positional_program_entry",
						"positional_program_play",
						"gait_change_quit_reset",
						"free_roam",
						"dance_demo",
						"_head_and_upper_body",
						"reset",
						"right_arm_throw",
						"right_arm_low_pickup",
						"right_arm_high_pickup",
						"right_arm_grab",
						"right_arm_give",
						"right_arm_roll",
						"movement_demo",
						"_right_arm",
						"sleep_wake_up",
						"left_arm_throw",
						"left_arm_low_pickup",
						"left_arm_high_pickup",
						"left_arm_grab",
						"left_arm_give",
						"left_arm_roll",
						"lie_down_sit_up_lie_down_stand_up",
						"_left_arm",
						"get_up",
						"right_kick",
						"right_push",
                        "right_chop",
						"left_chop",
						"left_push",
						"left_kick",
						"oops",
						"_hip_and_waist_tilt",
						"clear_program",
						"sound_program",
						"vision_program",
						"main_program",
						"perform_program",
						"guard_mode",
						"clear_entry",
						"high_5",
						"_both_arms",
						"bulldozer_forward",
						"laugh",
						"insult",
						"right_arm_drop",
						"left_arm_drop",
						"plan",
						"spare_change",
						"hey_baby",
						"_head_only",
						"bulldozer_backward",
						"roar",
						"diode",
						"fetch",
						"danger",
						"calm_down",
						"hug",
						"burp",
						"_head_and_upper_body",
						"power_down",
						"robosapien_v2_interaction",
						"roboraptor_interaction",
						"robopet_interaction",
						"manual_color_mode_daylight",
						"manual_color_mode_indoor_yellow",
						"manual_color_mode_indoor_white",
						"dont_press",
						"_upper_body_only" };

static int codes2[NCMDSAPIEN2] = { 0x300, 0x3aa, 0x383, 0x380, 0x381, 0x352, 0x390, 0x382, 0x350,
                          0x320, 0x353, 0x355, 0x356, 0x357, 0x358, 0x359, 0x35a,
						  0x354, 0x328, 0x386, 0x35c, 0x35d, 0x35e, 0x35f, 0x360,
						  0x361, 0x351, 0x330, 0x364, 0x362, 0x365, 0x366, 0x367,
						  0x368, 0x363, 0x35b, 0x340, 0x3f4, 0x3f1, 0x3f0, 0x3f5,
						  0x3f6, 0x3f2, 0x3f3, 0x369, 0x338, 0x36a, 0x36c, 0x36d,
						  0x36e, 0x36f, 0x370, 0x371, 0x36b, 0x348, 0x372, 0x374,
						  0x375, 0x376, 0x377, 0x378, 0x379, 0x373, 0x310, 0x384,
                          0x385, 0x387, 0x388, 0x389, 0x38a, 0x38b, 0x37a, 0x318 };

static char* petcmd[NCMDPET] = { "wake_up", "sleep", "stop", "guard", "demo", "good_dog",
                          "bad_dog", "turn_left", "turn_right", "forward", "backward",
						  "roll_over", "jump", "scratch", "howl", "paw", "play_dead",
						  "relief", "break_wind", "rock" };

static int petcodes[NCMDPET] = { 0x2c1, 0x2c1, 0x28e, 0x2c3, 0x2c8, 0x2c4, 0x2c5, 0x280,
                            0x288, 0x286, 0x287, 0x2e1, 0x2e6, 0x2e9, 0x2e3, 0x2e4,
							0x2e2, 0x2e5, 0x2e7, 0x2e8 };

static LARGE_INTEGER freq, c1, c2, c3;
static long long interrupt_frequency;
static double limiting;
inline void init()
{
  QueryPerformanceCounter(&c2);
}
inline void pause(int n)
{
  if (n > 1) 
  {
    for (int m = 0; m < n; m++) pause(1);
    return;
  }

  c1 = c2; 
  QueryPerformanceCounter(&c2);

  if ((double)(c2.QuadPart - c3.QuadPart) > limiting) 
  {
	 WaitForSingleObject(hevent, INFINITE);
	 QueryPerformanceCounter(&c3);
  }
  else if (c2.QuadPart > c3.QuadPart) c3.QuadPart += interrupt_frequency;
  
  do { QueryPerformanceCounter(&c2); } while (c2.QuadPart - c1.QuadPart < (long long)(n * unit));
}


// sends the specified code through the IR tower
void CsapienCtrl::send(int code, int nowakeup)
{
  int x = (code < 0x100)?128:2048;

  DWORD written;
  char *buf = "\0x00";
  if (!nowakeup)
  {
	  WriteFile(handle, buf, 1, &written, 0);
      Sleep(100);
  }

  SetPriorityClass(GetCurrentProcess(), REALTIME_PRIORITY_CLASS);
  SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_TIME_CRITICAL);

  timeBeginPeriod(1);
  ei = 0;
  hevent = CreateEvent(0, FALSE, FALSE, 0);
  timeSetEvent(1, 0, (LPTIMECALLBACK)hevent, 0, TIME_PERIODIC | TIME_CALLBACK_EVENT_SET);
  WaitForSingleObject(hevent, INFINITE);
  QueryPerformanceCounter(&c3);
  init(); 
  do { QueryPerformanceCounter(&c2); } while (c2.QuadPart - c1.QuadPart < (long long)(unit));

  EscapeCommFunction(handle, SETBREAK);
  init();
  pause(8);

  while (x)
  {
	EscapeCommFunction(handle, CLRBREAK);
    pause((code & x)?4:1);

	EscapeCommFunction(handle, SETBREAK);
    pause(1);

	x >>= 1;
  }
  EscapeCommFunction(handle, CLRBREAK);
  timeKillEvent(1);
  timeEndPeriod(1);
  CloseHandle(hevent);
  SetPriorityClass(GetCurrentProcess(), NORMAL_PRIORITY_CLASS);
  SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_NORMAL);
}

// converts command of given name to hexcode
int CsapienCtrl::decode(LPCSTR sapien_cmd, int version)
{
  int i;
  if (version == 1) // RoboSapien
  {
    for (i = 0; i < NCMDSAPIEN; i++)
	  if (strcmp(cmd[i], sapien_cmd) == 0)
		  return 128 + i;
  }
  else if (version == 2) // RoboSapien V2 
  {
    int dir = 0;
	LPCSTR s;
    if (sapien_cmd[0] == 'D')
	{
		s = sapien_cmd + 2;
		dir = sapien_cmd[1] - '0';
	}
	else s = sapien_cmd;
	for (i = 0; i < NCMDSAPIEN2; i++)
	  if (strcmp(cmd2[i], s) == 0)
	    return codes2[i] + dir;
  }
  else // RoboPet
  {
	for (i = 0; i < NCMDPET; i++)
	  if (strcmp(petcmd[i], sapien_cmd) == 0)
	    return petcodes[i];
  }
  return 0;
}

// opens port with IR tower (such as COM1) and initializes 
void CsapienCtrl::open(LPCTSTR port)
{
  if (!QueryPerformanceFrequency(&freq)) return;
  unit = (double)(freq.QuadPart) / 1200.0;
  limiting = (double)freq.QuadPart * 160.0 / 1000000.0;  /* number of ticks per 160 usec */ 
  interrupt_frequency = (long long)((double)freq.QuadPart / 1024.0); /* period of multimedia timer */
  handle = CreateFile(port, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);
  if (handle != INVALID_HANDLE_VALUE) initialized = 1;
  else initialized = 0;
}

// close the IR tower port
void CsapienCtrl::close(void)
{
	if (initialized) CloseHandle(handle);
	initialized = 0;
}
