// sapien.cpp : sapien go forward

#ifdef WIN32
#include <windows.h>
#else
#include <unistd.h>
#include <string.h>
#include <time.h>
#include <errno.h>
#include <sched.h>
#include <sys/time.h>
#include <sys/io.h>
#endif

#include <stdio.h>

#define NCMDSAPIEN	128
#define NCMDSAPIEN2	73
#define NCMDPET		20

#ifndef WIN32
#define HANDLE int
#else
static HANDLE hevent;
#endif

static double unit;
static unsigned char usemmtimer;
static char *cmd[NCMDSAPIEN] = { "turn_right", "right_arm_up", "right_arm_out", "tilt_body_right",
	                "right_arm_down", "right_arm_in", "walk_forward", "walk_backward",
					"turn_left", "left_arm_up", "left_arm_out", "tilt_body_left",
					"left_arm_down", "left_arm_in", "stop", "-", "master_program",
					"play", "right_program", "left_program", "sonic_program",
					"-", "-", "-", "quiet_execute", "-", "quiet_execute_with_subroutines", "-",
					"-", "-", "-", "-",
					"right_turn_step", "right_hand_thump", "right_hand_throw",
					"sleep", "right_hand_pickup", "lean_backward", "forward_step",
					"backward_step", "left_turn_step", "left_hand_thump",
					"left_hand_throw", "listen", "left_hand_pickup", "lean_forward" ,
					"reset", "-", "master_execute", "wakeup", "right_execute", "left_execute",
					"sonic_execute", "-", "-", "-", "-", "-", "-", "-", "-", "-", "-", "-",
					"right_hand_strike_3", "right_hand_sweep",
					"burp", "right_hand_strike", "high_5", "right_hand_strike_1",
					"bulldozer", "oops", "left_hand_strike_3", "left_hand_sweep",
					"whistle", "left_hand_strike_2", "talkback", "left_hand_strike_1",
					"roar", "-", "all_demo", "power_off", "demo_1", "demo_2", "dance", "-", "karate_chop",
					"-","-","-","-","-","-","-","-","-","-","-","-","-","-","-","-","-","-","-","-",
					"-","-","-","-","-","-","-","-","-","-","-",
					"feet_shuffle", "-","-","-","-","nothing", "raise_arm_throw","-","-","-"  };

static char *cmd2[NCMDSAPIEN2] = { "_walking",
                        "stop",
						"sonic_sensors_on_off",
						"vision_systems_on_off",
						"positional_program_entry",
						"positional_program_play",
						"gait_change_quit_reset",
						"free_roam",
						"dance_demo",
						"_head_and_upper_body",
						"reset",
						"right_arm_throw",
						"right_arm_low_pickup",
						"right_arm_high_pickup",
						"right_arm_grab",
						"right_arm_give",
						"right_arm_roll",
						"movement_demo",
						"_right_arm",
						"sleep_wake_up",
						"left_arm_throw",
						"left_arm_low_pickup",
						"left_arm_high_pickup",
						"left_arm_grab",
						"left_arm_give",
						"left_arm_roll",
						"lie_down_sit_up_lie_down_stand_up",
						"_left_arm",
						"get_up",
						"right_kick",
						"right_push",
                        "right_chop",
						"left_chop",
						"left_push",
						"left_kick",
						"oops",
						"_hip_and_waist_tilt",
						"clear_program",
						"sound_program",
						"vision_program",
						"main_program",
						"perform_program",
						"guard_mode",
						"clear_entry",
						"high_5",
						"_both_arms",
						"bulldozer_forward",
						"laugh",
						"insult",
						"right_arm_drop",
						"left_arm_drop",
						"plan",
						"spare_change",
						"hey_baby",
						"_head_only",
						"bulldozer_backward",
						"roar",
						"diode",
						"fetch",
						"danger",
						"calm_down",
						"hug",
						"burp",
						"_head_and_upper_body",
						"power_down",
						"robosapien_v2_interaction",
						"roboraptor_interaction",
						"robopet_interaction",
						"manual_color_mode_daylight",
						"manual_color_mode_indoor_yellow",
						"manual_color_mode_indoor_white",
						"dont_press",
						"_upper_body_only" };

static int codes2[NCMDSAPIEN2] = { 0x300, 0x3aa, 0x383, 0x380, 0x381, 0x352, 0x390, 0x382, 0x350,
                          0x320, 0x353, 0x355, 0x356, 0x357, 0x358, 0x359, 0x35a,
						  0x354, 0x328, 0x386, 0x35c, 0x35d, 0x35e, 0x35f, 0x360,
						  0x361, 0x351, 0x330, 0x364, 0x362, 0x365, 0x366, 0x367,
						  0x368, 0x363, 0x35b, 0x340, 0x3f4, 0x3f1, 0x3f0, 0x3f5,
						  0x3f6, 0x3f2, 0x3f3, 0x369, 0x338, 0x36a, 0x36c, 0x36d,
						  0x36e, 0x36f, 0x370, 0x371, 0x36b, 0x348, 0x372, 0x374,
						  0x375, 0x376, 0x377, 0x378, 0x379, 0x373, 0x310, 0x384,
                          0x385, 0x387, 0x388, 0x389, 0x38a, 0x38b, 0x37a, 0x318 };

static char* petcmd[NCMDPET] = { "wake_up", "sleep", "stop", "guard", "demo", "good_dog",
                          "bad_dog", "turn_left", "turn_right", "forward", "backward",
						  "roll_over", "jump", "scratch", "howl", "paw", "play_dead",
						  "relief", "break_wind", "rock" };

static int petcodes[NCMDPET] = { 0x2c1, 0x2c1, 0x28e, 0x2c3, 0x2c8, 0x2c4, 0x2c5, 0x280,
                            0x288, 0x286, 0x287, 0x2e1, 0x2e6, 0x2e9, 0x2e3, 0x2e4,
							0x2e2, 0x2e5, 0x2e7, 0x2e8 };

static LARGE_INTEGER freq, c1, c2, c3;
static long long interrupt_frequency;
static double limiting;
inline void init()
{
	QueryPerformanceCounter(&c2);
}

inline void pause(int n)
{
#ifdef WIN32
  if (usemmtimer)
  {
	 if (n > 1) 
	 {
	   for (int m = 0; m < n; m++) pause(1);
	   return;
	 }

	 c1 = c2; 
	 QueryPerformanceCounter(&c2);

	 if ((double)(c2.QuadPart - c3.QuadPart) > limiting) 
	 {
		 WaitForSingleObject(hevent, INFINITE);
		 QueryPerformanceCounter(&c3);
	 }
	 else if (c2.QuadPart > c3.QuadPart) c3.QuadPart += interrupt_frequency;
  }
  else c1 = c2;
  
  do { QueryPerformanceCounter(&c2); } while (c2.QuadPart - c1.QuadPart < (long long)(n * unit));
#else
  long d = ((long)n * (long)1000000) / (long)1200;
  struct timeval c1;
  struct timezone tz;
  gettimeofday(&c1, &tz);
  time_t newsec = c1.tv_sec;
  suseconds_t newusec = c1.tv_usec + d;
  while (newusec > 999999)
  {
    newusec -= 1000000;
    newsec++;
  }
  do { gettimeofday(&c1, &tz); } while ((c1.tv_sec < newsec) || (c1.tv_usec < newusec));
#endif
}

#ifndef WIN32

static int padr;
inline void break_set(HANDLE f)
{
  unsigned char b = inb(padr + 3);
  outb_p((unsigned char)(b|64), (int)(padr + 3));
}

inline void break_clear(HANDLE f)
{
  unsigned char b = inb(padr + 3);
  outb_p((unsigned char)b&(unsigned char)!64, padr + 3);
}

#else

inline void break_clear(HANDLE f)
{
  EscapeCommFunction(f, CLRBREAK);
}

inline void break_set(HANDLE f)
{
  EscapeCommFunction(f, SETBREAK);
}

#endif

void sapien_send(HANDLE f, int b, int version)
{
  int x = (version == 1)?128:2048;

#ifdef WIN32
	if (!SetPriorityClass(GetCurrentProcess(), REALTIME_PRIORITY_CLASS))
		printf("Warning: cannot set the process realtime priority class: err=%ld\n", GetLastError());
	if (!SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_TIME_CRITICAL))
		printf("Warning: cannot set thread priority to time critical: err=%ld\n", GetLastError());

	if (usemmtimer)
    {
      timeBeginPeriod(1);
      hevent = CreateEvent(0, FALSE, FALSE, 0);
      timeSetEvent(1, 0, (LPTIMECALLBACK)hevent, 0, TIME_PERIODIC | TIME_CALLBACK_EVENT_SET);
	  WaitForSingleObject(hevent, INFINITE);
	  QueryPerformanceCounter(&c3);
	  usemmtimer = 0; init(); pause(1); usemmtimer = 1;
    }
#else
    sched_param p;
	p.sched_priority = 50;
    if (sched_setscheduler(0, SCHED_FIFO, &p))
	  printf("Warning: cannot set real time scheduling, sapien should be run as root (or with setuid root)\n"); 
#endif

  break_set(f);
  init();
  pause(8);
  
  while (x)
  {
	break_clear(f);
    pause((b & x)?4:1);

	break_set(f);
    pause(1);

	x >>= 1;
  }
  break_clear(f);

#ifdef WIN32
  if (usemmtimer) 
  { 
	timeKillEvent(1);
	timeEndPeriod(1);
	CloseHandle(hevent);
  }
  SetPriorityClass(GetCurrentProcess(), NORMAL_PRIORITY_CLASS);
  SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_NORMAL);
#else
  p.sched_priority = 0;
  sched_setscheduler(0, SCHED_OTHER, &p);
#endif

}

int sapien_decode(char *sapien_cmd, int version)
{
  int i;
  if (version == 1) // RoboSapien
  {
    for (i = 0; i < NCMDSAPIEN; i++)
	  if (strcmp(cmd[i], sapien_cmd) == 0)
		  return 128 + i;
  }
  else if (version == 2) // RoboSapien V2
  {
    int dir = 0;
	char *s;
    if (sapien_cmd[0] == 'D')
	{
		s = sapien_cmd + 2;
		dir = sapien_cmd[1] - '0';
	}
	else s = sapien_cmd;
	for (i = 0; i < NCMDSAPIEN2; i++)
	  if (strcmp(cmd2[i], s) == 0)
	   return codes2[i] + dir;
  }
  else if (version == 3) // RoboPet
  {
	for (i = 0; i < NCMDPET; i++)
	  if (strcmp(petcmd[i], sapien_cmd) == 0)
	    return petcodes[i];
  }
  printf("sapien: unrecognized command: %s\n", sapien_cmd);
  return 0;
}

int main(int argc, char* argv[])
{
  int i;

  if (argc == 2)
    if ((strcmp(argv[1], "-?") == 0) ||
        (strcmp(argv[1], "-h") == 0) ||
		(strcmp(argv[1], "--help") == 0) ||
		(strcmp(argv[1], "/?") == 0)) argc = 1;

  if (argc == 1)
  {
	  printf("usage: sapien command|code|-script filename [-port portname] [-nowakeup] [-v2|-pet] [-mmtimer]\n\n");
	  printf("        codes are specified in hexadecimal as 0xCC\n");
	  printf("        specify -v2 for Sapien V2 or RoboRaptor, and -pet for RoboPet,\n");
	  printf("         default is RoboSapien v1.\n");
	  printf("        -mmtimer will use windows multimedia timers instead of busy waiting\n");
	  printf("        script should have 1 cmd/line preceeded by time in milliseconds\n");
	  printf("         and space; empty lines and those starting with # are ingored\n");
	  printf("        to view the list of commands for RoboSapien, run sapien -commands\n");
	  printf("        to view the list of commands for RoboSapien V2, run sapien -commandsv2\n");
	  printf("        to view the list of commands for RoboPet, run sapien -commandspet\n");
	  return 0;
  }

  if (argc == 2)
  {
    if (strcmp(argv[1], "-commands") == 0)
	{
	  printf("\nThe following commands are recognized for RoboSapien:\n");
	  for (i = 0; i < NCMDSAPIEN; i++)
	    if (cmd[i][0] != '-') printf("           %s (%x)\n", cmd[i], 128 + i);
	  return 0;
    }
	else if (strcmp(argv[1], "-commandsv2") == 0)
	{
	  printf("\nThe following commands are recognized for RoboSapien V2:\n");
	  for (i = 0; i < NCMDSAPIEN2; i++)
	    if (cmd2[i][0] != '_') printf("           %s (%x)\n", cmd2[i], codes2[i]);
		else printf("           DX%s (%x)\n", cmd2[i], codes2[i]);
      printf("\nIn the commands starting with DX, replace X with direction: \n");
      printf("  0 - Up/Forward\n  1 - Down/Backward\n  2 - Left\n  3 - Right\n  4 - Up and Left\n  5 - Up and Right\n  6 - Down and Left\n");
	  printf("  7 - Down and Right\n");
	  return 0;
    }
	else if (strcmp(argv[1], "-commandspet") == 0)
	{
	  printf("\nThe following commands are recognized for RoboPet:\n");
      for (i = 0; i < NCMDPET; i++)
	    printf("           %s (%x)\n", petcmd[i], petcodes[i]);
	  return 0;
	}
  }

  int nowakeup = 0;
  char *outport = "COM1";
  int version = 1;
  usemmtimer = 0;

  for (i = 2; i < argc; i++)
    if (strcmp(argv[i], "-port") == 0)
	{
	  if (i < argc - 1) outport = argv[++i];
	}
	else if (strcmp(argv[i], "-v2") == 0)
	  version = 2;
	else if (strcmp(argv[i], "-pet") == 0)
	  version = 3;
	else if (strcmp(argv[i], "-nowakeup") == 0)
	  nowakeup = 1;
#ifdef WIN32
	else if (strcmp(argv[i], "-mmtimer") == 0)
	{
	  usemmtimer = 1;
	  TIMECAPS tc;
	  timeGetDevCaps(&tc, sizeof(tc));
	  if (tc.wPeriodMin > 1) 
	  {
		  printf("warning: the multimedia timer resolution is %d, which renders them useless\n", tc.wPeriodMin);
		  usemmtimer = 0;
	  }
	}
#endif

  char *filename = 0;
  int code = 0;
  if ((argv[1][0] == '0') && (argv[1][1] == 'x'))
  {
	  sscanf(argv[1] + 2, "%x", &code);
	  if ((code > 0xFF) && (version == 1)) version = 2;
  }
  else if (strcmp(argv[1], "-script") != 0)
  {
	  if (!(code = sapien_decode(argv[1], version)))
		  return 1;
  }
  else if (argc > 2) filename = argv[2];
  else
  {
	  printf("sapien: missing script file name after -script\n");
	  return 1;
  }

#ifdef WIN32
  if (!QueryPerformanceFrequency(&freq))
  {
	  printf("high resolution timer not supported. giving up.\n");
	  return 1;
  }
  unit = (double)freq.QuadPart / 1200.0;
  limiting = (double)freq.QuadPart * 160.0 / 1000000.0;  /* number of ticks per 160 usec */ 
  interrupt_frequency = (long long)((double)freq.QuadPart / 1024.0); /* period of multimedia timer */
  HANDLE FHandle = CreateFile(outport, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);
  if (FHandle==INVALID_HANDLE_VALUE)
  {
	  printf("error opening port\n");
	  return 0;
  }
#else

  HANDLE FHandle = 0;
  if (strcmp(outport, "COM1") == 0) padr = 0x3f8;
  else if (strcmp(outport, "COM2") == 0) padr = 0x2f8;
  else if (strcmp(outport, "COM3") == 0) padr = 0x3e8;
  else if (strcmp(outport, "COM4") == 0) padr = 0x2e8;
  else 
  {
    printf("sapien: unrecognized port %s, use COM1-4\n", outport);
    return 0;
  }

  if (iopl(3))  //get access to low-level serial port (line-control register)
  {
    printf("sapien: cannot acquire access to port %s.\nYou have to run the program as root (or with setuid root)\n", outport);
	return 0;
  }

#endif

  if (!nowakeup)
  {
#ifdef WIN32
      char *buf = "\0x00";
      DWORD written;
	  WriteFile(FHandle, buf, 1, &written, 0);
      Sleep(100);
#else
      outb_p(0, padr);
      struct timespec tm;
      tm.tv_sec = 0;
      tm.tv_nsec = 100000000;
      nanosleep(&tm, 0);
#endif
  }

  if (!filename) sapien_send(FHandle, code, version);
  else
  {
	  FILE *f = fopen(filename, "r");
	  if (!f)
	  {
		  printf("sapien: error opening file %s, errno=%d\n", filename, errno);
		  return 1;
	  }
	  char buf[52];
	  long t;

  	  while (fgets(buf, 50, f))
	  {
		  if (buf[strlen(buf) - 1] == '\n') buf[strlen(buf) - 1] = '\0';
		  if (strlen(buf) == 0) continue;
		  if (buf[0] == '#') continue;
		  char command[50];
		  sscanf(buf, "%ld %s", &t, command);
#ifdef WIN32
		  LARGE_INTEGER t1, t2;
		  long long lt = freq.QuadPart * (long long)t / (long long)1000;
  	      QueryPerformanceCounter(&t1);
		  do { Sleep(1); QueryPerformanceCounter(&t2); } while (t2.QuadPart - t1.QuadPart < lt);
#else
		  struct timespec tm;
          tm.tv_sec = (time_t)(t / 1000);
          tm.tv_nsec = (long)(t % 1000) * (long)1000000;
          nanosleep(&tm, 0);
#endif
		  if ((command[0] == '0') && (command[1] == 'x'))
			  sscanf(command + 2, "%x", &code);
		  else code = sapien_decode(command, version);
		  sapien_send(FHandle, code, version);
	  }

	  fclose(f);
  }
#ifdef WIN32
  CloseHandle(FHandle);
#else
  iopl(0);
#endif

}

